    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ----------------------
    028     * AbstractXYDataset.java
    029     * ----------------------
    030     * (C) Copyright 2004, 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited).
    033     * Contributor(s):   -;
    034     *
    035     * $Id: AbstractXYDataset.java,v 1.2.2.1 2005/10/25 21:36:51 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 05-May-2004 : Version 1 (DG);
    040     * 15-Jul-2004 : Switched getX() with getXValue() and getY() with
    041     *               getYValue() (DG);
    042     * 18-Aug-2004 : Moved from org.jfree.data --> org.jfree.data.xy (DG);
    043     *
    044     */
    045
    046    package org.jfree.data.xy;
    047
    048    import org.jfree.data.DomainOrder;
    049    import org.jfree.data.general.AbstractSeriesDataset;
    050
    051    /**
    052     * An base class that you can use to create new implementations of the
    053     * {@link XYDataset} interface.
    054     */
    055    public abstract class AbstractXYDataset extends AbstractSeriesDataset
    056                                            implements XYDataset {
    057
    058        /**
    059         * Returns the order of the domain (X) values.
    060         *
    061         * @return The domain order.
    062         */
    063        public DomainOrder getDomainOrder() {
    064            return DomainOrder.NONE;
    065        }
    066
    067        /**
    068         * Returns the x-value (as a double primitive) for an item within a series.
    069         *
    070         * @param series  the series index (zero-based).
    071         * @param item  the item index (zero-based).
    072         *
    073         * @return The value.
    074         */
    075        public double getXValue(int series, int item) {
    076            double result = Double.NaN;
    077            Number x = getX(series, item);
    078            if (x != null) {
    079                result = x.doubleValue();
    080            }
    081            return result;
    082        }
    083
    084        /**
    085         * Returns the y-value (as a double primitive) for an item within a series.
    086         *
    087         * @param series  the series index (zero-based).
    088         * @param item  the item index (zero-based).
    089         *
    090         * @return The value.
    091         */
    092        public double getYValue(int series, int item) {
    093            double result = Double.NaN;
    094            Number y = getY(series, item);
    095            if (y != null) {
    096                result = y.doubleValue();
    097            }
    098            return result;
    099        }
    100
    101    }